//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LawnGreen
#property indicator_color2  Red
#property indicator_color3  White
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern bool   UseOSMA              = true;
extern bool   UseMTOSMA            = false;
extern int    OSMAFastPeriod       = 24;
extern int    OSMASlowPeriod       = 48;
extern int    OSMASignalPeriod     = 2;
extern int    OSMAPrice            = PRICE_CLOSE;
extern int    NemaPeriod           = 20;
extern int    NemaDepth            = 2;
extern bool   OSMAZeroPosition     = false;
extern bool   UseEldersImpulse     = false;
extern int    EimpEmaPeriod        = 13;
extern int    EimpMacdFastPeriod   = 12;
extern int    EimpMacdSlowPeriod   = 26;
extern int    EimpMacdSignalPeriod =  9;
extern int    EimpPrice            = PRICE_CLOSE;
extern bool   UseBOMP              = false;
extern double BompSmoothPeriod     = 90;
extern double BompSmoothPhase      =  0;
extern bool   UseNmc               = false;
extern int    NmcPeriod            = 40;
extern int    NmcPrice             = PRICE_CLOSE;
extern int    NmcTemaPeriod        =  1;


//
//
//
//
//

double valueUp[];
double valueDn[];
double valueNe[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,valueUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,valueDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,valueNe); SetIndexStyle(2,DRAW_HISTOGRAM);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][15];
#define _osmaFast  0
#define _osmaSlow  1
#define _osmaSign  2
#define _osmaOsma  3
#define _osmaTren  4
#define _eimpema   5
#define _eimpmacdv 6
#define _eimpmacds 7
#define _eimpmacdo 8
#define _eimpTren  9
#define _bomp     10
#define _bompTren 11
#define _nmc      12
#define _nma      13
#define _nmcTren  14
double tBuffer[][9];
#define iPrc 6
#define iPrp 7
#define iMom 8

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)    != Bars) ArrayResize(work   ,Bars);
           if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

   //
   //
   //
   //
   //

      double osmaAFast = 2.0 / (1.0 + OSMAFastPeriod);
      double osmaASlow = 2.0 / (1.0 + OSMASlowPeriod);
      double osmaASign = 2.0 / (1.0 + OSMASignalPeriod);
      double eimpAlpha = 2.0 / (1.0 + EimpMacdSignalPeriod);

      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iNema(iMA(NULL,0,1,0,MODE_SMA,OSMAPrice,i),NemaPeriod,NemaDepth,i,0);
         if (r==0)
         {
            work[r][_osmaFast] = price;
            work[r][_osmaSlow] = price;
            work[r][_osmaSign] = price;
            continue;
         }

         //
         //
         //
         //
         //
           
         double result = 0;
         double max    = 0;

         if (UseOSMA)
         {
            max++;
            if (UseMTOSMA)
            {
               work[r][_osmaOsma] = iOsMA(NULL,0,OSMAFastPeriod,OSMASlowPeriod,OSMASignalPeriod,OSMAPrice,i);
            }
            else
            {
               work[r][_osmaFast] = work[r-1][_osmaFast]+osmaAFast*(price-work[r-1][_osmaFast]);
               work[r][_osmaSlow] = work[r-1][_osmaSlow]+osmaASlow*(price-work[r-1][_osmaSlow]);
                     double macd = work[r][_osmaFast]-work[r][_osmaSlow];
               work[r][_osmaSign] = work[r-1][_osmaSign]+osmaASign*(macd -work[r-1][_osmaSign]);
               work[r][_osmaOsma] = macd-work[r][_osmaSign];
            }               
            work[r][_osmaTren] = 0;
            if (OSMAZeroPosition)
            {
               if (work[r][_osmaOsma]>work[r-1][_osmaOsma] && work[r][_osmaOsma]>0) work[r][_osmaTren]= 1;
               if (work[r][_osmaOsma]<work[r-1][_osmaOsma] && work[r][_osmaOsma]<0) work[r][_osmaTren]=-1;
            }
            else
            {
               if (work[r][_osmaOsma]>work[r-1][_osmaOsma]) work[r][_osmaTren]= 1;
               if (work[r][_osmaOsma]<work[r-1][_osmaOsma]) work[r][_osmaTren]=-1;
            }                     
            result += work[r][_osmaTren];
         }
         
         //
         //
         //
         //
         //
         
         if (UseEldersImpulse)
         {
            max++;
            work[r][_eimpema]   = iMA(NULL,0,EimpEmaPeriod,0,MODE_EMA,EimpPrice,i); 
            work[r][_eimpmacdv] = iMA(NULL,0,EimpMacdFastPeriod,0,MODE_EMA,EimpPrice,i)-iMA(NULL,0,EimpMacdSlowPeriod,0,MODE_EMA,EimpPrice,i);
            work[r][_eimpmacds] = work[r-1][_eimpmacds]+eimpAlpha*(work[r][_eimpmacdv]-work[r-1][_eimpmacds]);
            work[r][_eimpmacdo] = work[r][_eimpmacdv]-work[r][_eimpmacds];
            work[r][_eimpTren]  = 0;
                  if (work[r][_eimpema]<work[r-1][_eimpema] && work[r][_eimpmacdo]<work[r-1][_eimpmacdo]) work[r][_eimpTren] = -1;
                  if (work[r][_eimpema]>work[r-1][_eimpema] && work[r][_eimpmacdo]>work[r-1][_eimpmacdo]) work[r][_eimpTren] =  1;
                     result += work[r][_eimpTren];
         }         
         
         //
         //
         //
         //
         //
         
         if (UseBOMP)
         {
            max++;
            double range = MathMax(High[i]-Low[i],Point);
            double buo   = (High[i]-Open[i])/range;
            double buc   = (Close[i]-Low[i])/range;
            double buoc  = MathMax(Close[i]-Open[i],0)/range;
            double beo   = (Open[i]-Low[i])/range;
            double bec   = (High[i]-Close[i])/range;
            double beoc  = MathMax(Open[i]-Close[i],0)/range;
               work[r][_bompTren] = work[r-1][_bompTren];
               work[r][_bomp]     = iSmooth((buo+buc+buoc)/3.0-(beo+bec+beoc)/3.0,BompSmoothPeriod,BompSmoothPhase,i);
                  if (work[r][_bomp]>0) work[r][_bompTren] =  1;
                  if (work[r][_bomp]<0) work[r][_bompTren] = -1;
                     result += work[r][_bompTren];
         }

         //
         //
         //
         //
         //
         
         if (UseNmc)
         {
            max++;
            double rawPrice  = iMA(NULL,0,1,0,MODE_SMA,NmcPrice,i);
            double currPrice = iTema(rawPrice,i);
               if (currPrice > 0)
                     tBuffer[r][iPrc] = MathLog(currPrice);
               else  tBuffer[r][iPrc] = 0.00;
      
            //
            //
            //
            //
            //
         
            double nmm = iNmmFunction(1,i);
            double nmr = iNmrFunction(1,i);
            double tmp = (MathAbs(nmm)*nmr+MathAbs(nmr)*nmm)/2.00;
            if (tmp > 0)
                   work[r][_nmc] =  MathSqrt( tmp);
            else   work[r][_nmc] = -MathSqrt(-tmp);
                   work[r][_nmcTren] = work[r-1][_nmcTren];
                   tBuffer[r][iMom]  = work[r][_nmc]-work[r-1][_nmc];
                   work[r][_nma]     = work[r-1][_nma]+iNmaRatio(r,NmcPeriod)*(work[r][_nmc]-work[r-1][_nma]);
            
                     if (work[r][_nmc]>work[r][_nma]) work[r][_nmcTren] =  1;
                     if (work[r][_nmc]<work[r][_nma]) work[r][_nmcTren] = -1;
                        result += work[r][_nmcTren];
         }
         
         //
         //
         //
         //
         //

        valueUp[i] = EMPTY_VALUE;         
        valueDn[i] = EMPTY_VALUE;         
        valueNe[i] = EMPTY_VALUE;         
           if (result== max) valueUp[i] = 1;
           if (result==-max) valueDn[i] = 1;
           if (valueUp[i]==EMPTY_VALUE && valueDn[i]==EMPTY_VALUE) valueNe[i] = 1;
      }
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars); s*= 10;
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//    natural market mirror
//
//
//

double iNmmFunction(int startPeriod, int tPos)
{
   int    endPeriod = startPeriod*NmcPeriod;
   int    pos       = Bars-tPos-1;
   double sum       = 0.00;
   double currPrice = tBuffer[pos][iPrc];
      
   for (int i= startPeriod; i <= endPeriod; i += startPeriod)
           sum += (currPrice-tBuffer[pos-i][iPrc])/MathSqrt(i);
   return((sum/NmcPeriod)*1000.00);
}

//
//
//
//    natural market river
//
//
//

double iNmrFunction(int startPeriod, int tPos)
{
   int    endPeriod = startPeriod*NmcPeriod;
   int    pos       = Bars-tPos-1;
   double sum       = 0.00;
      
   for (int i=startPeriod; i <= endPeriod; i+=startPeriod)
          sum += (tBuffer[pos-i+startPeriod][iPrc]-tBuffer[pos-i][iPrc])*(MathSqrt(i)-MathSqrt(i-startPeriod));
   return(sum*1000.00);
}

//
//
//
//
//

double iNmaRatio(int r,int period)
{
   double momRatio = 0.00;
   double sumMomen = 0.00;
   double ratio    = 0.00;

   //
   //
   //
   //
   //
   
      for (int k = 0; k<period; k++)
      {
         sumMomen += MathAbs(tBuffer[r-k][iMom]);
         momRatio +=         tBuffer[r-k][iMom]*(MathSqrt(k+1)-MathSqrt(k));
      }
   if (sumMomen != 0) ratio = MathAbs(momRatio)/sumMomen;
   return(ratio);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double iTema(double price,int pos,int sbuf=0)
{
   int i  = Bars-pos-1;
   int ia = sbuf+0;
   int ib = sbuf+1;
   int ic = sbuf+2;
   double alpha = 2.0 /(1.0 + NmcTemaPeriod);
   
   if (i < 1)
      {
         tBuffer[i][ia] = price;
         tBuffer[i][ib] = price;
         tBuffer[i][ic] = price;
      }
   else
      {
         tBuffer[i][ia] = tBuffer[i-1][ia]+alpha*(price         -tBuffer[i-1][ia]);
         tBuffer[i][ib] = tBuffer[i-1][ib]+alpha*(tBuffer[i][ia]-tBuffer[i-1][ib]);
         tBuffer[i][ic] = tBuffer[i-1][ic]+alpha*(tBuffer[i][ib]-tBuffer[i-1][ic]);
      }
   return(3*tBuffer[i][ia] - 3*tBuffer[i][ib] + tBuffer[i][ic]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workNema[][50][1];
double coeffs[][1];
double depths[];

double iNema(double price, double period, int depth, int r, int forValue)
{
   double alpha  = 2.0/(1.0+period);
   double result = 0;
   double sign   = 1;

   if (ArrayRange(workNema,0)!=Bars) ArrayResize(workNema,Bars);
   if (ArraySize(depths)<forValue)   ArrayResize(depths,Bars);
   if (depths[forValue] != depth)
   {
      int size = ArrayRange(coeffs,0);
         if (size < depth) ArrayResize(coeffs,depth+1);
         for(int k=0; k<=depth; k++) coeffs[k][forValue] = factorial(depth)/(factorial(depth-k)*factorial(k));
                                     depths[forValue]    = depth;
   }
   
   //
   //
   //
   //
   //

   r = Bars-r-1;   
   for (k=0; k<depth; k++, sign *= -1)
   {
      if (r<2)
            workNema[r][k][forValue] = price;
      else  workNema[r][k][forValue] = workNema[r-1][k][forValue]+alpha*(price-workNema[r-1][k][forValue]);
      price  = workNema[r][k][forValue];
      result += price*sign*coeffs[k+1][forValue];
   }
   return(result);               
}

//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}